;;; kakeimemo.el --- RTC Adapter for NIFTY for Emacsen
;;;	$Id: kakeimemo.el,v 1.1 2003/02/11 04:18:41 wackie Exp $	


;; Copyright (C) 2003 by Takashi KIMURA

;; Author: Takashi KIMURA <wackie@mbb.nifty.ne.jp>
;; Keywords: 

;; This file is free software; you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation; either version 2, or (at your option)
;; any later version.

;; This file is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.

;; You should have received a copy of the GNU General Public License
;; along with GNU Emacs; see the file COPYING.  If not, write to
;; the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
;; Boston, MA 02111-1307, USA.

;;; Code:
;;(autoload 'kakei "kakeimemo" nil t )
;;If you use kakei in mew-summary with "k" ,set like below
;;(add-hook 'mew-summary-mode-hook
;;	  (lambda ()
;;	    (define-key mew-summary-mode-map "k" 'kakei-mew-summary)))
(defvar kakei-directory (expand-file-name "~/"))

(defun kakei-make-file-name ( y m d )
  (concat kakei-directory y "_" m "_" d ".howm"))

(defun kakei-format-output (strings)
  (concat "$$$ " strings))

(defun kakei ()
;;; output data from mail buffer
  (interactive)
  (let ((strings) (file) (body-flag nil) (year) (month) (day))
    (save-excursion
      (goto-char (point-min))
      (while (= 0 (forward-line))
	(setq strings 
	      (buffer-substring (line-beginning-position) (line-end-position)))
	(cond ((and
		;; $BG/7nF|$N<hF@(B
		(not body-flag)
		(string-match "^[Dd][Aa][Tt][Ee]:" strings)
		)
	       (setq strings (replace-match "" nil nil strings))
	       (string-match 
		"[A-Za-z][A-Za-z][A-Za-z], \\([0-9]+\\) \\([A-Za-z][A-Za-z][A-Za-z]\\) \\([0-9][0-9][0-9][0-9]\\)" strings )
	       (setq 
		year (match-string 3 strings)
		month (cdr
		       (assoc-ignore-case
			(match-string 2 strings) kakei-month-table))
		day (match-string 1 strings))
	       ;; $BF|IU$N(B0$B%5%W%l%9(B
	       (when (> 2 (length day))
		 (setq day (concat "0" day)))
	       ;; $B=PNO%U%!%$%kL>(B
	       (setq file (kakei-make-file-name year month day)) 
	       (kakei-output file 
			     (concat "= [" year "/" month "/" day "]")))
	      ;; $B%a!<%k$N%\%G%#$NH=Dj(B
	      ((equal "" strings) (setq body-flag t))

	      ((and (string-match "^[1-9]" strings ) body-flag)
	       (kakei-output file (kakei-format-output strings)) ))))))

(defun kakei-output ( file strings )
  (with-temp-buffer
    (insert strings)
    (newline 1)
    (append-to-file (point-min) (point-max) file)
    ))

(defun kakei-mew-summary ()
  (interactive)
  (save-excursion
    (mew-summary-display t)
    (mew-summary-goto-msg-mode)
    (kakei)
    (mew-message-goto-summary)
    ))

(defvar kakei-month-table 
  '(( "Jan" . "01" )
    ( "Feb" . "02" )
    ( "Mar" . "03" )
    ( "Apr" . "04" )
    ( "May" . "05" )
    ( "Jun" . "06" )
    ( "Jul" . "07" )
    ( "Aug" . "08" )
    ( "Sep" . "09" )
    ( "Oct" . "10" )
    ( "Nov" . "11" )
    ( "Dec" . "12" )))

; $Update: Tue Feb 11 13:17:12 2003 $
